
#include "allegro.h"
#include "g3d.h"

BITMAP *tex_granite(int size, int rgb, int d, int f)
{
   BITMAP *tex = create_bitmap(size, size);
   int i, r, g, b;
   int r0 = rgb2r(rgb) - d/2;
   int g0 = rgb2g(rgb) - d/2;
   int b0 = rgb2b(rgb) - d/2;

   clear_to_color(tex, rgb2h(rgb));
   for (i=0; i<size*size*f/100; i++) {
      r = r0 + (random() & d); clip_c(r);
      g = g0 + (random() & d); clip_c(g);
      b = b0 + (random() & d); clip_c(b);
      putpixel(tex, random() & (size-1), random() & (size-1), makecol(r, g, b));
   }
   return tex;
}

BITMAP *tex_brick(int size, int rgb, int d, int f)
{
   BITMAP *tex = create_bitmap(size, size);
   int i, x, y, r, g, b;
   int r0 = rgb2r(rgb) - d/2;
   int g0 = rgb2g(rgb) - d/2;
   int b0 = rgb2b(rgb) - d/2;
   int s2 = size >> 1;

   clear_to_color(tex, rgb2h(rgb));
   for (i=0; i<size*size*f/100; i++) {
      r = r0 + (random() & d);
      g = g0 + (random() & d);
      b = b0 + (random() & d);
      clip_c(r); clip_c(g); clip_c(b);
      putpixel(tex, random() & (size-1), random() & (size-1), makecol(r, g, b));
   }
   for (x=0; x<size; x++) {
      for (y=0; y<size; y++) {
         if ( (y == 0) ||
              (y == size - 1) ||
              (y == s2) ||
              (y == s2 - 1) ||
              ((y < s2) && ((x == 0) || (x == size - 1))) ||
              ((y > s2) && ((x == s2) || (x == s2 - 1))) ) {
            int c = getpixel(tex, x, y);
            r = getr(c) - d; clip_c(r);
            g = getg(c) - d; clip_c(g);
            b = getb(c) - d; clip_c(b);
            putpixel(tex, x, y, makecol(r, g, b));
         }
      }
   }
   return tex;
}
